IF EXISTS(SELECT *
            FROM SYSOBJECTS, SYSUSERS
           WHERE SYSOBJECTS.NAME = 'STATUS_LOTECTB_MOVBANCARIO'
             AND TYPE   = 'TR'
             AND SYSUSERS.UID  = SYSOBJECTS.UID
             AND SYSUSERS.NAME = USER)
   DROP TRIGGER STATUS_LOTECTB_MOVBANCARIO
GO

CREATE TRIGGER STATUS_LOTECTB_MOVBANCARIO ON MOVBANCARIO
FOR DELETE
AS
DECLARE @V_CDLOTE           VARCHAR(20);
DECLARE @V_NRLANCLOTE       VARCHAR(06);
DECLARE @V_DTINICCTBL       DATETIME;
DECLARE @V_DTFINACCTBL      DATETIME;
DECLARE @V_CDEMPRESA        VARCHAR(2);
DECLARE @OLD_IDMOVBANC      VARCHAR(1);
DECLARE @OLD_CDREDUCONT     VARCHAR(3);
DECLARE @OLD_NRMOVBANC      VARCHAR(10)
DECLARE @OLD_DTMOVBANC      DATETIME;
DECLARE @V_IDTPGERACAOCONT  VARCHAR(01);
DECLARE @V_INSERTED         INT;
DECLARE @V_DELETED          INT;
DECLARE @NEW_IDSTATUSCTBBANC VARCHAR(01);
DECLARE @OLD_IDSTATUSCTBBANC VARCHAR(01);
BEGIN

   SELECT @V_IDTPGERACAOCONT = IDTPGERACAOCONT FROM PARAMCTBL;

   IF @V_IDTPGERACAOCONT <> 'O' BEGIN

      DECLARE C_MOVBANCARIO CURSOR FOR
        SELECT IDMOVBANC, CDREDUCONT, NRMOVBANC, DTMOVBANC, IDSTATUSCTBBANC
          FROM DELETED;
      OPEN C_MOVBANCARIO;

      FETCH NEXT FROM C_MOVBANCARIO INTO @OLD_IDMOVBANC, @OLD_CDREDUCONT, @OLD_NRMOVBANC, @OLD_DTMOVBANC, @OLD_IDSTATUSCTBBANC;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @OLD_IDMOVBANC = 'C' BEGIN
               SELECT @V_CDEMPRESA = MAX(CDEMPRESA)
                 FROM MOVCREDBANC
                WHERE CDREDUCONT = @OLD_CDREDUCONT
                  AND NRMOVBANC  = @OLD_NRMOVBANC;
         END
         ELSE BEGIN
               SELECT @V_CDEMPRESA = MAX(CDEMPRESA)
                 FROM MOVDEBBANC
                WHERE CDREDUCONT = @OLD_CDREDUCONT
                  AND NRMOVBANC  = @OLD_NRMOVBANC;
         END;

         SELECT @V_DTINICCTBL = DTINICCTBL, @V_DTFINACCTBL = DTFINACCTBL
           FROM CONTOPECTBL
          WHERE CDEMPRESA = @V_CDEMPRESA;

         SELECT @V_INSERTED = COUNT(*) FROM INSERTED;

         SELECT @V_DELETED = COUNT(*) FROM DELETED;

         IF ((@V_DELETED <> 0) AND (@V_INSERTED = 0)) BEGIN
            IF ((@OLD_DTMOVBANC >= @V_DTINICCTBL AND @OLD_DTMOVBANC <= @V_DTFINACCTBL) OR (@V_CDEMPRESA IS NULL)) BEGIN

               DECLARE C_RELAMBANCLANLOT CURSOR FOR
                  SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                    FROM RELAMBANCLANLOT
                   WHERE  CDREDUCONT = @OLD_CDREDUCONT
                     AND  NRMOVBANC  = @OLD_NRMOVBANC;
               OPEN C_RELAMBANCLANLOT;

               FETCH NEXT FROM C_RELAMBANCLANLOT INTO @V_CDLOTE, @V_NRLANCLOTE;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                  EXEC REVERTE_LOTE @V_CDEMPRESA, @V_CDLOTE;

                  DELETE FROM RELAMBANCLANLOT
                   WHERE CDEMPRESA  = @V_CDEMPRESA
                     AND NRLANCLOTE = @V_NRLANCLOTE
                     AND CDREDUCONT = @OLD_CDREDUCONT
                     AND NRMOVBANC  = @OLD_NRMOVBANC;

                  DELETE FROM LANCLOTE
                   WHERE CDEMPRESA  = @V_CDEMPRESA
                     AND CDLOTE     = @V_CDLOTE
                     AND NRLANCLOTE = @V_NRLANCLOTE;

                  FETCH NEXT FROM C_RELAMBANCLANLOT INTO @V_CDLOTE, @V_NRLANCLOTE;
               END;
               CLOSE C_RELAMBANCLANLOT;
               DEALLOCATE C_RELAMBANCLANLOT;
            END
            ELSE BEGIN
               RAISERROR('Excluso no permitida, data da movimentao fora do perodo de integrao financeiro.', 16,1);
            END;
         END;
         FETCH NEXT FROM C_MOVBANCARIO INTO @OLD_IDMOVBANC, @OLD_CDREDUCONT, @OLD_NRMOVBANC, @OLD_DTMOVBANC, @OLD_IDSTATUSCTBBANC;
      END;
      CLOSE C_MOVBANCARIO;
      DEALLOCATE C_MOVBANCARIO;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'STATUS_LOTECTB_MOVBANCARIO','5.09.000';
GO